#!/usr/bin/env python
from __future__ import print_function

import json
import urllib
import socket
import SocketServer
import pamela as pam

__EMPTY_USER = {"Username": "", "Password": "", "Role": "", "Id": ""}

def auth(*args):
    username = args[0]
    password = urllib.unquote(args[1]).decode('utf8')
    try:
        pam.authenticate(username, password)
        return True
    except Exception as ex:
        return False


def process_cmd(cmd):
    ret = __EMPTY_USER
    try:
        user = json.loads(cmd)
        if (auth(user['Username'], user['Password'])):
            ret = {"Id": 1, "Username": user['Username'], "Role": 1}
    except Exception as ex:
        print(ex)

    return json.dumps(ret)


class ThreadedRequestHandler(SocketServer.BaseRequestHandler):
    def handle(self):
        ret = process_cmd(self.request.recv(1024))
        if ret:
            self.request.sendall(ret)


class ThreadedServer(SocketServer.ThreadingMixIn, SocketServer.UnixStreamServer):

    SYSTEMD_FIRST_SOCKET_FD = 3

    def __init__(self, server_address, handler_cls):
        SocketServer.UnixStreamServer.__init__(self, server_address, handler_cls, bind_and_activate=False)
        self.socket = socket.fromfd(self.SYSTEMD_FIRST_SOCKET_FD, self.address_family, self.socket_type)


def main():
    server = ThreadedServer(None, ThreadedRequestHandler)
    server.serve_forever()


if __name__ == "__main__":
    main()
